



void initaff()
{
  Serial.println("Debut initialisation affichage");
  display.init();
  u8g2Fonts.begin(display); // connect u8g2 procedures to Adafruit GFX
  delay(1000);
  display.setRotation(0); // 0--> No rotation ,  1--> rotate 90 deg
  u8g2Fonts.setFontMode(1);                 // use u8g2 transparent mode (this is default)
  u8g2Fonts.setFontDirection(0);            // left to right (this is default)
  u8g2Fonts.setForegroundColor(fg);         // apply Adafruit GFX color
  u8g2Fonts.setBackgroundColor(bg);         // apply Adafruit GFX color
  u8g2Fonts.setFont(u8g2_font_helvR14_tf);  // select u8g2 font from here:  https://github.com/olikraus/u8g2/wiki/fntlistall

  //u8g2Fonts.setFont(u8g2_font_logisoso32_tr); //u8g2_font_logisoso32_tn--->numbers only to save memory ; u8g2_font_logisoso32_tr , u8g2_font_logisoso32_tf -->numbers&letters

    //display.setFullWindow();
    display.setPartialWindow(0, 0, display.width(), display.height());
    
    display.firstPage();
  do
  {
    display.fillScreen(bg);

    u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
    u8g2Fonts.setCursor(20, 40);
    u8g2Fonts.print("Bienvenue sur ALOHA");
   
    display.drawBitmap(50, 80, AlohaBitmap, 300, 147, fg);

    u8g2Fonts.setFont(u8g2_font_helvR14_tf);
    u8g2Fonts.setCursor(150, 280);
    u8g2Fonts.print("Initialisation...");
    
  }
  while (display.nextPage());
  
  Serial.println("Fin initialisation affichage");
  
}

void affpagevit()
{

    display.setPartialWindow(0, 0, display.width(), display.height());

    display.firstPage();
    do
    {
      display.fillScreen(bg);

      u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
      u8g2Fonts.setCursor(25, 40);
      u8g2Fonts.print("Vitesse GPS et loch");

      u8g2Fonts.setFont(u8g2_font_helvR14_tf);
      u8g2Fonts.setCursor(70, 70);
      u8g2Fonts.print("Nombre de satellites en vue : ");
      u8g2Fonts.println(gpsnbsat);
   
      u8g2Fonts.setFont(u8g2_font_helvR14_tf);
      u8g2Fonts.setCursor(15, 100);
      u8g2Fonts.print("Date & Heure GPS : ");
      u8g2Fonts.print(gpsjour);
      u8g2Fonts.print("-");
      u8g2Fonts.print(gpsmois);
      u8g2Fonts.print("-");
      u8g2Fonts.print(gpsannee);
      u8g2Fonts.print("/");
      u8g2Fonts.print(gpsheureloc);
      u8g2Fonts.print("h");
      u8g2Fonts.print(gpsminute);
      u8g2Fonts.print("m");
      u8g2Fonts.print(gpsseconde);     
      u8g2Fonts.print("s");

      if (gpsvitesseknt < 10) {
        u8g2Fonts.setFont(u8g2_font_helvR14_tf);
        u8g2Fonts.setCursor(100, 130);
        u8g2Fonts.print("Vitesse eau : ");
        u8g2Fonts.print(vitesseeauknt,1);
        u8g2Fonts.print(" kt");
      }
      else {
        u8g2Fonts.setCursor(100, 130);
        u8g2Fonts.print("Vitesse eau : ");
        u8g2Fonts.print(vitesseeauknt,0);
        u8g2Fonts.print(" kt");
      }
   
      u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
      u8g2Fonts.setCursor(50, 180);
      u8g2Fonts.print("Vitesse fond (kt)");

      if (gpsvitesseknt < 10) {
        u8g2Fonts.setFont(u8g2_font_logisoso92_tn);
        u8g2Fonts.setCursor(160, 290);
        u8g2Fonts.println(gpsvitesseknt,1);
      }
      else {
        u8g2Fonts.setFont(u8g2_font_logisoso92_tn);
        u8g2Fonts.setCursor(160, 290);
        u8g2Fonts.println(gpsvitesseknt,0);
      }
      

      u8g2Fonts.setFont(u8g2_font_helvR14_tf);
      u8g2Fonts.setCursor(350, 190);
      u8g2Fonts.print("Lisse");

      u8g2Fonts.setCursor(355, 210);
      u8g2Fonts.print(vitessesollisse,1);
      
      u8g2Fonts.setCursor(350, 230);
      u8g2Fonts.print("Max");

      u8g2Fonts.setCursor(355, 250);
      u8g2Fonts.print(vitessesolmaxknt,1);

      u8g2Fonts.setCursor(350, 270);
      u8g2Fonts.print("Moy");

      u8g2Fonts.setCursor(355, 290);
      u8g2Fonts.print(vitessesolmoyknt,1);

      int positionaxeabscisses=290;
      int positionaxeordonnees=30;
      int longueuraxeabscisse=nbvitessesbuffer;
      int longueuraxeordonnee=90;
      int margelongueurordonnee=20;
      int maxaffichcourbe=10;
      
      display.drawLine(positionaxeordonnees, positionaxeabscisses, positionaxeordonnees + longueuraxeabscisse, positionaxeabscisses, fg);
      display.drawLine(positionaxeordonnees, positionaxeabscisses, positionaxeordonnees, positionaxeabscisses - longueuraxeordonnee, fg);
      display.drawLine(positionaxeordonnees - 5, positionaxeabscisses - longueuraxeordonnee + margelongueurordonnee, 
      positionaxeordonnees + 5, positionaxeabscisses - longueuraxeordonnee + margelongueurordonnee, fg);
      u8g2Fonts.setCursor(positionaxeordonnees - 20, positionaxeabscisses - longueuraxeordonnee + margelongueurordonnee + 5);
      u8g2Fonts.setFont(u8g2_font_helvR08_tf);
      u8g2Fonts.print(maxaffichcourbe);
      display.fillTriangle(positionaxeordonnees + longueuraxeabscisse,positionaxeabscisses + 5,positionaxeordonnees + longueuraxeabscisse,
      positionaxeabscisses -5,positionaxeordonnees + longueuraxeabscisse + 10,positionaxeabscisses, fg);
      display.fillTriangle(positionaxeordonnees - 5,positionaxeabscisses - longueuraxeordonnee,positionaxeordonnees + 5,
      positionaxeabscisses - longueuraxeordonnee,positionaxeordonnees,positionaxeabscisses - longueuraxeordonnee - 10, fg);

      vitesseBuffer.push(gpsvitesseknt);
      for (int i=0;i < nbvitessesbuffer;i++) {
        display.drawPixel(positionaxeordonnees + i, positionaxeabscisses - vitesseBuffer[i]*(longueuraxeordonnee-margelongueurordonnee)/maxaffichcourbe, fg);
        //display.fillCircle(positionaxeordonnees + i, positionaxeabscisses - vitesseBuffer[i]*(longueuraxeordonnee-20)/maxaffichcourbe, 3, fg);
      }
      
    }
    while (display.nextPage());
  
}

void affpageposcap() {

  display.setPartialWindow(0, 0, display.width(), display.height());
  
  display.firstPage();
  do
  {
    display.fillScreen(bg);

    u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
    u8g2Fonts.setCursor(60, 40);
    u8g2Fonts.print("Position et cap");

    u8g2Fonts.setFont(u8g2_font_helvR14_tf);
    u8g2Fonts.setCursor(20, 70);
    u8g2Fonts.print("Latitude : ");
    u8g2Fonts.print(gpslatitude,2);
    u8g2Fonts.print(" °");
   
    u8g2Fonts.setCursor(220, 70);
    u8g2Fonts.print("Longitude : ");
    u8g2Fonts.print(gpslongitude,2);
    u8g2Fonts.print(" °");

    u8g2Fonts.setFont(u8g2_font_helvR18_tf);
    u8g2Fonts.setCursor(10, 120);
    u8g2Fonts.print("Cap magnétique : ");
    u8g2Fonts.print(capm,0);
    u8g2Fonts.print(" °");

    int xcentrecerclecapm  = 320;
    int ycentrecerclecapm = 110;
    int rayoncerclecapm = 30;
    
    display.drawCircle(xcentrecerclecapm, ycentrecerclecapm, rayoncerclecapm, fg);
    display.drawLine(xcentrecerclecapm, ycentrecerclecapm, xcentrecerclecapm + rayoncerclecapm*sin(capm*3.14/180),
    ycentrecerclecapm - rayoncerclecapm*cos(capm*3.14/180), fg);
    
   
    u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
    u8g2Fonts.setCursor(50, 180);
    u8g2Fonts.print("Cap geographique");

    u8g2Fonts.setFont(u8g2_font_logisoso92_tn);
    u8g2Fonts.setCursor(110, 290);
    u8g2Fonts.println(gpscap,0);

    int xcentrecerclecapg  = 340;
    int ycentrecerclecapg = 240;
    int rayoncerclecapg = 50;
    
    display.drawCircle(xcentrecerclecapg, ycentrecerclecapg, rayoncerclecapg, fg);
    display.drawLine(xcentrecerclecapg, ycentrecerclecapg, xcentrecerclecapg + rayoncerclecapg*sin(gpscap*3.14/180),
    ycentrecerclecapg - rayoncerclecapg*cos(gpscap*3.14/180), fg);

    u8g2Fonts.setFont(u8g2_font_helvR14_tf);
    u8g2Fonts.setCursor(10, 240);
    u8g2Fonts.print("Vitesse (kt)");

    u8g2Fonts.setCursor(40, 260);
    u8g2Fonts.print(vitessesollisse,1);
    
  }
  while (display.nextPage());
  
}

void affpageattitude() {
  
  display.setPartialWindow(0, 0, display.width(), display.height());
  
  display.firstPage();
  do
  {
    display.fillScreen(bg);

    u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
    u8g2Fonts.setCursor(70, 40);
    u8g2Fonts.print("Environnement");

    u8g2Fonts.setFont(u8g2_font_helvR14_tf);
    u8g2Fonts.setCursor(80, 60);
    u8g2Fonts.print("Temperature boitier : ");
    u8g2Fonts.print(temperature,1);
    u8g2Fonts.print(" °");

    u8g2Fonts.setCursor(120, 80);
    u8g2Fonts.print("Pression : ");
    u8g2Fonts.print(pression,0);
    u8g2Fonts.print(" hPa");

    u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
    u8g2Fonts.setCursor(130, 130);
    u8g2Fonts.print("Attitude");
    
    u8g2Fonts.setFont(u8g2_font_helvR14_tf);
    u8g2Fonts.setCursor(40, 150);
    u8g2Fonts.print("Roulis : ");
    u8g2Fonts.print(roulis,0);
    u8g2Fonts.print(" °");

    u8g2Fonts.setCursor(250, 150);
    u8g2Fonts.print("Tangage : ");
    u8g2Fonts.print(tangage,0);
    u8g2Fonts.print(" °");

    int niveaumer = 270;
    int largeurbateau = 30;
    int longueurbateau = 100;
    int longueurproue = 20;
    int tiranteau = 20;
    int hauteurbateau = 10;
    int marge = 10;
    int positionmatroulis = 90;
    int positionmattangage = 310;
    int hauteurmats = 110;
    int xboutdumatroulis ;
    int yboutdumatroulis;
    int xboutdumattangage;
    int yboutdumattangage;

    xboutdumatroulis = positionmatroulis - hauteurmats*sin(roulis*3.14/180);
    yboutdumatroulis = niveaumer - hauteurmats*cos(roulis*3.14/180);

    xboutdumattangage = positionmattangage - hauteurmats*sin(tangage*3.14/180);
    yboutdumattangage = niveaumer - hauteurmats*cos(tangage*3.14/180);
    
    display.drawLine(marge, niveaumer, 400-marge, niveaumer, fg);
    display.drawLine(positionmatroulis, niveaumer, xboutdumatroulis, yboutdumatroulis, fg);
    display.drawLine(positionmattangage, niveaumer, xboutdumattangage, yboutdumattangage, fg);
    display.fillTriangle(positionmatroulis - largeurbateau/2, niveaumer - hauteurbateau, 
    positionmatroulis + largeurbateau/2, niveaumer - hauteurbateau, positionmatroulis, niveaumer + tiranteau, fg);
    display.fillRect(positionmattangage - longueurbateau/2, niveaumer - hauteurbateau, 
    longueurbateau, hauteurbateau + tiranteau, fg);
    display.fillTriangle(positionmattangage - longueurbateau/2, niveaumer - hauteurbateau,
    positionmattangage - longueurbateau/2, niveaumer + tiranteau,
    positionmattangage - longueurbateau/2 - longueurproue, niveaumer - hauteurbateau, fg);
    
  }
  while (display.nextPage());
  
}

void affpagemoydist() {

  display.setPartialWindow(0, 0, display.width(), display.height());
  
  display.firstPage();
  do
  {
    display.fillScreen(bg);

    u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
    u8g2Fonts.setCursor(0, 40);
    u8g2Fonts.print("Moyennes et distances");

    u8g2Fonts.setFont(u8g2_font_helvR14_tf);
    u8g2Fonts.setCursor(100, 70);
    u8g2Fonts.print("Vitesse moyenne : ");
    u8g2Fonts.print(vitessesolmoyknt,1);
    u8g2Fonts.print(" kt");

    u8g2Fonts.setCursor(120, 90);
    u8g2Fonts.print("Vitesse max : ");
    u8g2Fonts.print(vitessesolmaxknt,1);
    u8g2Fonts.print(" kt");

    u8g2Fonts.setCursor(150, 115);
    u8g2Fonts.print("Sur la duree");

    u8g2Fonts.setCursor(40, 135);
    u8g2Fonts.print(nbjours);
    u8g2Fonts.print(" jours ");
    u8g2Fonts.print(nbheures);
    u8g2Fonts.print(" heures ");
    u8g2Fonts.print(nbminutes);
    u8g2Fonts.print(" minutes ");
    u8g2Fonts.print(nbsecondes);
    u8g2Fonts.print(" secondes");

    u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
    u8g2Fonts.setCursor(30, 180);
    u8g2Fonts.print("Distance parcourue");

    if (distance < 10) {
      u8g2Fonts.setFont(u8g2_font_logisoso92_tn);
      u8g2Fonts.setCursor(100, 290);
      u8g2Fonts.println(distance,1);
    }
    else {
      u8g2Fonts.setFont(u8g2_font_logisoso92_tn);
      u8g2Fonts.setCursor(100, 290);
      u8g2Fonts.println(distance,0);
    }

    u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
    u8g2Fonts.setCursor(300, 250);
    u8g2Fonts.print("nM");
    
    
    }

  while (display.nextPage());
}

void affpagerazquestion() {

  display.setPartialWindow(0, 0, display.width(), display.height());
  
  display.firstPage();
  do
  {
    display.fillScreen(bg);

    u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
    u8g2Fonts.setCursor(70, 150);
    u8g2Fonts.print("RAZ historique ?");

    u8g2Fonts.setFont(u8g2_font_helvR14_tf);
    u8g2Fonts.setCursor(50, 200);
    u8g2Fonts.print("Si oui, appuyez encore sur le bouton");

    u8g2Fonts.setCursor(100, 250);
    u8g2Fonts.print("Annulation dans");

    u8g2Fonts.setCursor(240, 250);
    u8g2Fonts.print(3-tempsraz);

    u8g2Fonts.setCursor(260, 250);
    u8g2Fonts.print("secondes");
    
  }
  while (display.nextPage());
}

void affpagerazfait() {

  display.setPartialWindow(0, 0, display.width(), display.height());
  
  display.firstPage();
  do
  {
    display.fillScreen(bg);

    u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
    u8g2Fonts.setCursor(70, 150);
    u8g2Fonts.print("RAZ effectif");
    
  }
  while (display.nextPage());
}

void affpagemob() {
  
    display.setPartialWindow(0, 0, display.width(), display.height());
  
  display.firstPage();
  do
  {
    display.fillScreen(bg);

    u8g2Fonts.setFont(u8g2_font_logisoso32_tr);
    u8g2Fonts.setCursor(0, 40);
    u8g2Fonts.print("Man Over Board (MOB)");

    u8g2Fonts.setFont(u8g2_font_helvR14_tf);
    u8g2Fonts.setCursor(10, 70);
    u8g2Fonts.print("Lat MOB : ");
    u8g2Fonts.print(MOBlat,3);
    u8g2Fonts.print(" °");
   
    u8g2Fonts.setFont(u8g2_font_helvR14_tf);
    u8g2Fonts.setCursor(195, 70);
    u8g2Fonts.print("Long MOB : ");
    u8g2Fonts.print(MOBlong,3);
    u8g2Fonts.print(" °");

    u8g2Fonts.setCursor(190, 290);
    u8g2Fonts.print("Distance au MOB : ");
    u8g2Fonts.print(distancedumob,0);
    u8g2Fonts.print(" m");

    int xpositionbateau = 290;
    int ypositionbateau = 175;
    int dimensioncarte = 190;
    int longbateau = 20;
    int largbateau = 10;
    int longproue = 10;
    float echelle = 0;
    if (distancedumob < 50) echelle = (dimensioncarte/2)/50;
    else if (distancedumob >50 && distancedumob < 100) echelle = (dimensioncarte/2)/100;
    else if (distancedumob >100 && distancedumob < 150) echelle = (dimensioncarte/2)/150;
    else if (distancedumob >150 && distancedumob < 200) echelle = (dimensioncarte/2)/200;
    else if (distancedumob >200 && distancedumob < 250) echelle = (dimensioncarte/2)/250;
    else if (distancedumob >250 && distancedumob < 300) echelle = (dimensioncarte/2)/300;
    else if (distancedumob >300 && distancedumob < 350) echelle = (dimensioncarte/2)/350;
    else if (distancedumob >350 && distancedumob < 400) echelle = (dimensioncarte/2)/400;
    else if (distancedumob >400 && distancedumob < 450) echelle = (dimensioncarte/2)/450;
    else if (distancedumob >450 && distancedumob < 500) echelle = (dimensioncarte/2)/500;

    int diffcap=capaprendremob - gpscap;
    
    display.drawRoundRect(xpositionbateau - dimensioncarte/2, ypositionbateau - dimensioncarte/2, dimensioncarte, dimensioncarte, 30, fg);
    display.fillRect(xpositionbateau - largbateau/2, ypositionbateau -longbateau/2, largbateau, longbateau, fg);
    display.fillTriangle(xpositionbateau - largbateau/2, ypositionbateau -longbateau/2, 
    xpositionbateau + largbateau/2, ypositionbateau - longbateau/2,xpositionbateau, ypositionbateau - longbateau/2 - longproue, fg);
    display.fillCircle(xpositionbateau + distancedumob*echelle*sin(diffcap*3.14/180), 
    ypositionbateau - distancedumob*echelle*cos(diffcap*3.14/180), 5, fg);
   
    u8g2Fonts.setFont(u8g2_font_helvR14_tf);
    u8g2Fonts.setCursor(50, 120);
    u8g2Fonts.print("Cap bateau");
    u8g2Fonts.setCursor(90, 140);
    u8g2Fonts.print(gpscap,0);
    u8g2Fonts.print(" °");

    u8g2Fonts.setCursor(40, 210);
    u8g2Fonts.print("Cap a prendre");
    u8g2Fonts.setCursor(90, 230);
    u8g2Fonts.print(capaprendremob,0);
    u8g2Fonts.print(" °");
    
    }

  while (display.nextPage());

}

void affichage() {
    
    switch (a){ 

    case 0:   
        affpagevit();
    break;
    
    case 1:     
        affpageposcap();
    break;

    case 2: 
        affpageattitude();
    break;
 
    case 3:
        affpagemoydist();    
    break;
    
    }


}
