


void calculcapm()
{
 //this part is required to normalize the magnetic vector

 
 
 if (IMU.getMagX_uT()>xMagnetMax) {xMagnetMax = IMU.getMagX_uT();}
 if (IMU.getMagY_uT()>yMagnetMax) {yMagnetMax = IMU.getMagY_uT();}
 if (IMU.getMagZ_uT()>zMagnetMax) {zMagnetMax = IMU.getMagZ_uT();}
 
 if (IMU.getMagX_uT()<xMagnetMin) {xMagnetMin = IMU.getMagX_uT();}
 if (IMU.getMagY_uT()<yMagnetMin) {yMagnetMin = IMU.getMagY_uT();}
 if (IMU.getMagZ_uT()<zMagnetMin) {zMagnetMin = IMU.getMagZ_uT();}
 
 float norm;
 
 xMagnetMap = float(map(IMU.getMagX_uT(), xMagnetMin, xMagnetMax, -10000, 10000))/10000.0;
 yMagnetMap = float(map(IMU.getMagY_uT(), yMagnetMin, yMagnetMax, -10000, 10000))/10000.0;
 zMagnetMap = float(map(IMU.getMagZ_uT(), zMagnetMin, zMagnetMax, -10000, 10000))/10000.0;
 

//normalize the magnetic vector
norm= sqrt( sq(xMagnetMap) + sq(zMagnetMap));
xMagnetMap /=norm;
zMagnetMap /=norm;
 
//compare Applications of Magnetic Sensors for Low Cost Compass Systems by Michael J. Caruso
//for the compensated Yaw equations...
//http://www.ssec.honeywell.com/magnetic/datasheets/lowcost.pdf
capm=atan2(xMagnetMap, zMagnetMap) *180/PI;
if (capm < 0) capm=capm + 360;
}

void calculattitude() {
  roulis = atan2 (IMU.getAccelX_mss(),IMU.getAccelY_mss())*180/3.14;
  tangage = atan2 (IMU.getAccelZ_mss(),IMU.getAccelY_mss())*180/3.14;
}

void calculenvir() {
  temperature = bmp.readTemperature();
  pression = bmp.readPressure() / 100.0F;
}

void calculmoydist() {
  maintenant=millis();
  interval=float(maintenant-debut)/1000;
  debut=maintenant;
  nombresecondes=nombresecondes+interval;
  distance=distance+gpsvitesseknt*(interval/3600);
  nbjours=(nombresecondes/(60*60)/24);
  nbheures=(nombresecondes/(60*60))-(nbjours*24);
  nbminutes=(nombresecondes/60)-(nbjours*24*60)-(nbheures*60);
  nbsecondes=nombresecondes-(nbjours*24*60*60)-(nbheures*60*60)-(nbminutes*60);
  if (gpsvitesseknt>vitessesolmaxknt) {
    vitessesolmaxknt=gpsvitesseknt;
  }
  vitessesolmoyknt=distance/(nombresecondes/3600);
  tableauvitessesol[indicetableauvitesse] = gpsvitesseknt;
  indicetableauvitesse ++;
  if(indicetableauvitesse==10) indicetableauvitesse=0;
  vitessesollisse=0;
  int i;
  for(i=0;i<10;i++) {
    vitessesollisse=vitessesollisse+tableauvitessesol[i];
  }
  vitessesollisse=vitessesollisse/10;
}
  
